<?php

namespace App\Controller\Dashboard;

use App\Controller\Dashboard\Settings\CompanyTrait;
use App\Entity\Company\Company;
use App\Entity\Product\Product;
use App\Entity\Rent\Rent;
use App\Entity\User\User;
use App\Repository\Product\ProductRepository;
use App\Repository\User\UserRepository;
use EasyCorp\Bundle\EasyAdminBundle\Controller\AbstractDashboardController;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\IsGranted;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;

/**
 * Class RentDashboardController
 * @package App\Controller\Dashboard
 * @IsGranted ("IS_AUTHENTICATED_FULLY")
 */
class RentDashboardController extends AbstractDashboardController
{
    use CompanyTrait;
    /**
     * @Route("/rent", name="rent")
     *
     */
    public function index(): Response
    {
        return $this->redirect("/user"); // TODO: Change the autogenerated stub
    }

    /**
     * @Route("/company/{companySlug}/rent/{rentSlug}", name="app_company_rent_dashboard")
     */
    public function rentDashboard(Company $company, Rent $rent, UserRepository $repository): Response
    {
        $this->company = $company;
        $products = $rent->getProducts()->getValues();

        /*recuperer la personne à  l'origine de la rent */
        $usernameRent = $rent->getCreatedBy();
        $userRent = $repository->findOneBy(['username'=> $usernameRent]);

        /*recuperer la personne à  l'origine du contract, celui qui valide la rent*/
        $usernameContract = $rent->getContract()->getCreatedBy();
        $userContract = $repository->findOneBy(['username' => $usernameContract]);

        /*Récupération des produits pour avoir la quantité commandé*/
        $List =[] ;
        $productsGlRef = [];
        foreach($products as $product)
        {
            if (in_array($product->getGlobalReference(), $productsGlRef) ){
                $productsGlRef[] = $product->getGlobalReference();
            }
            else
            {
                $List []= $product;
                $productsGlRef[] = $product->getGlobalReference();
            }
        }
        $arrayQuantity = array_count_values($productsGlRef);

        /*Récupération TagTypeLimitation par produit et suppression des doublons */
        $infos =[];
        foreach ($products as $product)
        {
            if ($product->getTagTypeLimitations()){
                $values = $product->getTagTypeLimitations()->getValues();
                foreach ($values as $value)
                {
                    $infos[] = $value;
                }
            }
        }
        $infos = array_unique($infos);
        return $this->render('easyAdmin/rent/index.html.twig',[
            'rent' =>$rent,
            'products'=> $List,
            'company'=>$company,
            'companyPhones'=>$company->getPhones()->getValues(),
            'userRent'=>$userRent,
            'userRentPhones'=>$userRent->getPhones()->getValues(),
            'userContract'=>$userContract,
            'userContractPhones'=>$userContract->getPhones()->getValues(),
            'infos' => $infos,
            'arrayQuantity' => $arrayQuantity






        ]);
    }

}
